package org.jboss.cache.commands;

import org.jboss.cache.Fqn;
import org.jboss.cache.commands.legacy.read.LegacyGravitateDataCommand;
import org.jboss.cache.commands.legacy.write.CreateNodeCommand;
import org.jboss.cache.commands.legacy.write.LegacyEvictCommand;
import org.jboss.cache.commands.legacy.write.VersionedInvalidateCommand;
import org.jboss.cache.commands.read.GravitateDataCommand;
import org.jboss.cache.commands.write.EvictCommand;
import org.jboss.cache.commands.write.InvalidateCommand;

/**
 * Extends the default commands factory impl for optimistic locking.
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 * @deprecated will be removed with opt locking
 */
@Deprecated
@SuppressWarnings("deprecation")
public class OptimisticCommandsFactoryImpl extends CommandsFactoryImpl
{
   @Override
   public EvictCommand buildEvictFqnCommand(Fqn fqn)
   {
      EvictCommand command = new LegacyEvictCommand(fqn);
      command.initialize(notifier, dataContainer);
      return command;
   }

   @Override
   public InvalidateCommand buildInvalidateCommand(Fqn fqn)
   {
      VersionedInvalidateCommand command = new VersionedInvalidateCommand(fqn);
      command.initialize(txManager);
      command.initialize(cacheSpi, dataContainer, notifier);
      return command;
   }

   @Override
   public GravitateDataCommand buildGravitateDataCommand(Fqn fqn, Boolean searchSubtrees)
   {
      LegacyGravitateDataCommand command = new LegacyGravitateDataCommand(fqn, searchSubtrees, rpcManager.getLocalAddress());
      command.initialize(dataContainer, cacheSpi, buddyFqnTransformer);
      return command;
   }

   @Override
   public CreateNodeCommand buildCreateNodeCommand(Fqn fqn)
   {
      CreateNodeCommand command = new CreateNodeCommand(fqn);
      command.initialize(dataContainer);
      return command;
   }


   @Override
   public ReplicableCommand fromStream(int id, Object[] parameters)
   {
      ReplicableCommand command;
      boolean skipSetParams = false;
      switch (id)
      {
         case CreateNodeCommand.METHOD_ID:
         {
            CreateNodeCommand returnValue = new CreateNodeCommand(null);
            returnValue.initialize(dataContainer);
            command = returnValue;
            break;
         }
         case GravitateDataCommand.METHOD_ID:
         {
            LegacyGravitateDataCommand returnValue = new LegacyGravitateDataCommand(rpcManager.getLocalAddress());
            returnValue.initialize(dataContainer, cacheSpi, buddyFqnTransformer);
            command = returnValue;
            break;
         }
         case InvalidateCommand.METHOD_ID:
         {
            VersionedInvalidateCommand returnValue = new VersionedInvalidateCommand(null);
            returnValue.initialize(cacheSpi, dataContainer, notifier);
            command = returnValue;
            break;
         }
         default:
            // pass up to superclass
            command = super.fromStream(id, parameters);
            skipSetParams = true;
      }

      if (!skipSetParams) command.setParameters(id, parameters);
      return command;
   }
}
