package org.jboss.cache.commands;

import org.jboss.cache.transaction.GlobalTransaction;

/**
 * A write command that has a reference to a {@link org.jboss.cache.transaction.GlobalTransaction}.
 *
 * @author Mircea.Markus@jboss.com
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 2.2.0
 */
public interface WriteCommand extends DataCommand
{
   /**
    * @return a GlobalTransaction associated with this command.
    */
   GlobalTransaction getGlobalTransaction();

   /**
    * Sets a GlobalTransaction on this command.
    *
    * @param gtx global transaction to set
    */
   void setGlobalTransaction(GlobalTransaction gtx);
}
