package org.jboss.cache.commands.legacy.write;

import org.jboss.cache.Fqn;
import org.jboss.cache.InvocationContext;
import org.jboss.cache.NodeSPI;
import org.jboss.cache.commands.legacy.ReversibleCommand;
import org.jboss.cache.commands.write.PutDataMapCommand;
import org.jboss.cache.transaction.GlobalTransaction;

import java.util.HashMap;
import java.util.Map;

/**
 * A version of {@link org.jboss.cache.commands.write.PutDataMapCommand} which can be rolled back, for use with
 * pessimistic locking where changes are made directly on the data structures and may need to be reversed.
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 * @deprecated will be removed along with optimistic and pessimistic locking.
 */
@Deprecated
public class PessPutDataMapCommand extends PutDataMapCommand implements ReversibleCommand
{
   Map oldData;

   public PessPutDataMapCommand(GlobalTransaction globalTransaction, Fqn fqn, Map data)
   {
      super(globalTransaction, fqn, data);
   }

   public PessPutDataMapCommand()
   {
   }

   @Override
   public Object perform(InvocationContext ctx)
   {
      // first get a hold of existing data.
      NodeSPI node = ctx.lookUpNode(fqn);
      Map existingData = node == null ? null : node.getDataDirect();
      if (existingData != null && !existingData.isEmpty())
      {
         oldData = new HashMap(existingData); // defensive copy
      }
      return super.perform(ctx);
   }

   public void rollback()
   {
      if (trace) log.trace("rollback(" + globalTransaction + ", " + fqn + ", " + data + ")");
      NodeSPI n = dataContainer.peek(fqn, false, true);
      if (n != null)
      {
         n.clearDataDirect();
         if (oldData != null) n.putAllDirect(oldData);
      }
   }
}
