/**
 *
 */
package org.jboss.cache.eviction;

import org.jboss.cache.config.ConfigurationComponent;
import org.jboss.cache.config.ConfigurationException;
import org.jboss.cache.config.EvictionAlgorithmConfig;

/**
 * Configuration class for {@link NullEvictionAlgorithm}.
 *
 * @author Manik Surtani
 * @since 3.0
 */
public class NullEvictionAlgorithmConfig extends ConfigurationComponent implements EvictionAlgorithmConfig
{
   private static final long serialVersionUID = -6591180473728241737L;

   /**
    * No-op
    */
   public void reset()
   {
      // no-op
   }

   public String getEvictionAlgorithmClassName()
   {
      return NullEvictionAlgorithm.class.getName();
   }

   /**
    * No-op
    */
   public void validate() throws ConfigurationException
   {
      // no-op
   }

   public NullEvictionAlgorithmConfig clone() throws CloneNotSupportedException
   {
      return (NullEvictionAlgorithmConfig) super.clone();
   }
}