package org.jboss.cache.interceptors;

import org.jboss.cache.Fqn;
import org.jboss.cache.InvocationContext;
import org.jboss.cache.factories.annotations.Inject;
import org.jboss.cache.mvcc.MVCCNodeHelper;

/**
 * MVCC specific version of the LegacyDataGravitatorInterceptor
 *
 * @author Manik Surtani (<a href="mailto:manik@jboss.org">manik@jboss.org</a>)
 * @since 3.0
 */
public class DataGravitatorInterceptor extends LegacyDataGravitatorInterceptor
{
   MVCCNodeHelper helper;

   @Inject
   public void injectMvccNodeHelper(MVCCNodeHelper helper)
   {
      this.helper = helper;
   }

   @Override
   protected void wrapIfNeeded(InvocationContext ctx, Fqn fqnToWrap) throws InterruptedException
   {
      helper.wrapNodeForReading(ctx, fqnToWrap);
   }
}
